# Import SDK packages
from AWSIoTPythonSDK.MQTTLib import AWSIoTMQTTClient
import time
import sqlite3
import threading
import json
import os
from datetime import datetime
from threading import Thread
from models import *


# Custom MQTT message callback
def customCallback(client, userdata, message):
	print("Received a new message: ")
	print(message.payload)
	jsonresponse = json.loads(message.payload)
	if jsonresponse["topic"] == "light_temps":

		light = (jsonresponse["room"],jsonresponse["light"],datetime.now())
		lights_conn = create_conn(os.path.abspath(os.path.dirname(__file__) + "/databases/lights.db"))
		print (lights_conn)

		tem = (jsonresponse["room"],jsonresponse["temp"],jsonresponse["humi"],datetime.now())
		tem_conn = create_conn(os.path.abspath(os.path.dirname(__file__) + "/databases/temperature.db"))
		print tem_conn


		create_light(lights_conn, light)
		create_temp(tem_conn, tem)
	else:
		rfid_conn = create_conn("rfid.db")
	print("--------------\n\n")


host = "a26f9edjarcvo6.iot.us-west-2.amazonaws.com"
rootCAPath = "VeriSign-Class 3-Public-Primary-Certification-Authority-G5.pem"
certificatePath = "abc3cb84c2-certificate.pem.crt"
privateKeyPath = "abc3cb84c2-private.pem.key"

my_rpi = AWSIoTMQTTClient("basicSub")
my_rpi.configureEndpoint(host, 8883)
my_rpi.configureCredentials(rootCAPath, privateKeyPath, certificatePath)

my_rpi.configureOfflinePublishQueueing(-1)  # Infinite offline Publish queueing
my_rpi.configureDrainingFrequency(2)  # Draining: 2 Hz
my_rpi.configureConnectDisconnectTimeout(60)  # 10 sec
my_rpi.configureMQTTOperationTimeout(60)  # 5 sec

# Connect and subscribe to AWS IoT
print("Connecting to aws...")
my_rpi.connect()

topic = "greenhouse/sensors"
print("Starting subscription to.. {}".format(topic))

print("Listening..")
while True:
    try:
        my_rpi.subscribe(topic, 1, customCallback)
    except:
        print ("Error")
