from flask import redirect, render_template, request, session, url_for, Blueprint,jsonify,Response
import json
ajax = Blueprint("ajax", __name__)
from app.models import *
#from models import *

from AWSIoTPythonSDK.MQTTLib import AWSIoTMQTTClient
import time
import json
import os
from datetime import datetime
from threading import Thread



host = "a26f9edjarcvo6.iot.us-west-2.amazonaws.com"
rootCAPath = "VeriSign-Class 3-Public-Primary-Certification-Authority-G5.pem"
certificatePath = "abc3cb84c2-certificate.pem.crt"
privateKeyPath = "abc3cb84c2-private.pem.key"

my_rpi = AWSIoTMQTTClient("serverunitalarm")
my_rpi.configureEndpoint(host, 8883)
my_rpi.configureCredentials(rootCAPath, privateKeyPath, certificatePath)

my_rpi.configureOfflinePublishQueueing(-1)  # Infinite offline Publish queueing
my_rpi.configureDrainingFrequency(2)  # Draining: 2 Hz
my_rpi.configureConnectDisconnectTimeout(60)  # 10 sec
my_rpi.configureMQTTOperationTimeout(60)  # 5 sec
my_rpi.connect()
@ajax.route("/updatehomepage", methods=["GET","POST"])
def room_status_main():
    temperature_conn = create_conn("app/temperature.db")
    tests = get_data_homepage(temperature_conn)
    return Response(json.dumps(tests),  mimetype='application/json');

@ajax.route('/update_accesslog',methods=['GET'])
def accesslog_ajax():
    access_conn = create_conn("app/rfid.db")
    data_reversed = select_all_accessdata(access_conn)

    return jsonify(data_reversed)

@ajax.route('/update_temperature_room1',methods=['GET'])
def update_temperature_room1():
    temperature_conn = create_conn("app/temperature.db")
    data_reversed = select_all_room1_temperature(temperature_conn)
    return Response(json.dumps(data_reversed),  mimetype='application/json');

@ajax.route('/update_temperature_room1_table',methods=['GET'])
def update_temperature_room1_table():
    temperature_conn = create_conn("app/temperature.db")
    data_reversed = select_all_room1_temperature_table(temperature_conn)

    return jsonify(data_reversed)

@ajax.route('/update_temperature_room2',methods=['GET'])
def update_temperature_room2():
    temperature_conn = create_conn("app/temperature.db")
    data_reversed = select_all_room2_temperature(temperature_conn)
    return Response(json.dumps(data_reversed),  mimetype='application/json');

@ajax.route('/update_temperature_room2_table',methods=['GET'])
def update_temperature_room2_table():
    temperature_conn = create_conn("app/temperature.db")
    data_reversed = select_all_room2_temperature_table(temperature_conn)

    return jsonify(data_reversed)

@ajax.route('/raise_the_alert',methods=['GET'])
def raise_the_alert():
    roomnum = request.args.get('id')
    reply = {"room":roomnum.encode("utf-8")}
    reply = str(reply)
    reply = reply.replace("\'","\"")
    reply = reply.replace("[", "\"[")
    reply = reply.replace("]", "]\"")
    my_rpi.publish("lab/alarm", str(reply),0)
    return Response();
